'       ,  "PlotNom" - 19   (, 2310100000010020164).
'          (  2310100000:01:002:0164).
'    " "  ,      ":" (), .. 2310100000010020164.tif
'    .            .
'   ,        "Picture"      
'    ,    . .
'           .

Private Sub FillLink_Click()
 Dim result As Boolean
 Dim f_names() As String, f_filter() As String
 ReDim f_names(0) As String
 ReDim f_filter(1, 2) As String
 Dim tmp_str, k_nom As String
 Dim i As Integer
 f_filter(0, 0) = " "
 f_filter(1, 0) = "*.tif"
 '   .   
 result = MyGetFileName(OFEOpenForLoad, Dir, f_names(), f_filter())
 If Not result Then
  MsgBox "  ,   [].", 48, "Info"
  Exit Sub
 End If
 Dim pPropSet As IPropertySet
 Dim pWorkspaceFactory As IWorkspaceFactory
 Dim pWorkspace As IWorkspace
 Dim pFeatureWorkspace As IFeatureWorkspace
 Dim pWorkspaceEdit As IWorkspaceEdit
 Dim pFeatureClass As IFeatureClass
 Dim pNewFCursor As IFeatureCursor
 Dim pQFilt As IQueryFilter
 Dim pSelectionSet As ISelectionSet
 Dim mFeature As IFeature
 Dim mFCursor As IFeatureCursor
 Dim mField As Long
 Dim count As Long
 Dim sum As Long
 Set pPropSet = New PropertySet
 With pPropSet
  .SetProperty "Server", "spatial"
  .SetProperty "Instance", "sde:sqlserver:srv0"
  .SetProperty "database", "my_database"
  .SetProperty "user", "my_name"
  .SetProperty "password", "my_password"
  .SetProperty "version", "sde.DEFAULT"
 End With
 Dim pEditor As IEditor
 Dim pID As New UID
 pID = "esriEditor.Editor"
 Set pEditor = Application.FindExtensionByCLSID(pID)
 Set pWorkspaceFactory = New SdeWorkspaceFactory
 Set pWorkspace = pWorkspaceFactory.Open(pPropSet, 0)
 Set pFeatureWorkspace = pWorkspace
 Set pFeatureClass = pFeatureWorkspace.OpenFeatureClass("my_layer")
 Set pWorkspaceEdit = pFeatureWorkspace
  If pEditor.EditState <> esriStateEditing Then
   pEditor.StartEditing pWorkspaceEdit
  End If
 sum = 0
 '    
 For i = 0 To UBound(f_names)
  count = 0
  tmp_str = Dir & "\" & f_names(i)
  ' ""     
  k_nom = Left(f_names(i), 10) & ":" & Mid(f_names(i), 11, 2) & ":" _
          & Mid(f_names(i), 13, 3) & ":" & Mid(f_names(i), 16, 4)
  Set pQFilt = New QueryFilter
  '   
  pQFilt.WhereClause = "PlotNom ='" & k_nom & "'"
  Set pSelectionSet = pFeatureClass.Select(pQFilt, esriSelectionTypeIDSet, _
                                           esriSelectionOptionNormal, Nothing)
  Set mFCursor = pFeatureClass.Search(pQFilt, True)
  Set mFeature = mFCursor.NextFeature
  '  ,  
  Do While Not (mFeature Is Nothing)
   mField = mFeature.Fields.FindField("Picture")
   '   ,        
   If mFeature.Value(mField) = "" Or mFeature.Value(mField) = " " Or IsNull(mFeature.Value(mField)) Then
    pEditor.StartOperation
    mFeature.Value(mField) = tmp_str
    mFeature.Store
    pEditor.StopOperation "Save link for " & k_nom
    count = count + 1
    Set mFeature = mFCursor.NextFeature
   Else
    Set mFeature = mFCursor.NextFeature
   End If
  Loop
  sum = sum + count
  Set pQFilt = Nothing
  Set pSelectionSet = Nothing
  Set mFeature = Nothing
  Set mFCursor = Nothing
 Next i
  'cleanup
  Set pPropSet = Nothing
  Set pWorkspaceFactory = Nothing
  Set pWorkspace = Nothing
  Set pFeatureWorkspace = Nothing
  Set pWorkspaceEdit = Nothing
  Set pFeatureClass = Nothing
  Set pNewFCursor = Nothing
  Set pQFilt = Nothing
  Set pSelectionSet = Nothing
  Set mFeature = Nothing
  Set mFCursor = Nothing
  Set pEditor = Nothing
  Set pID = Nothing
 If sum = 0 Then
  MsgBox "  ", vbOKOnly, "Completed"
 Else
  MsgBox sum & "  ", vbOKOnly, "Completed"
 End If
End Sub
